Debian Bug report logs - #603114
be more careful in passing arguments to debootstrap

version graph

Package: live-build; Maintainer for live-build is Live Systems Maintainers <debian-live@lists.debian.org>; Source for live-build is src:live-build.

Reported by: Michael Hudson <michael.hudson@canonical.com>

Date: Wed, 10 Nov 2010 23:15:01 UTC

Severity: normal

Found in version live-build/2.0~a21-1

Fixed in version live-build/3.0~a18-1

Done: Daniel Baumann <daniel@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Wed, 10 Nov 2010 23:15:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Hudson <michael.hudson@canonical.com>:
New Bug report received and forwarded. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Wed, 10 Nov 2010 23:15:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Michael Hudson <michael.hudson@canonical.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: live-build: be more careful in passing arguments to debootstrap
Date: Thu, 11 Nov 2010 12:12:23 +1300
[Message part 1 (text/plain, inline)]
Package: live-build
Version: 2.0~a21-1ubuntu1~linaro4ubuntu4
Severity: normal
Tags: patch

Hi, as part of experiementing with having live-build automatically invoke
qemu-deboostrap when cross building, I found that live-build was a little
careless about the way it passed arguments to debootstrap.

In particular, it passes some options with values as --option value rather than
the documented --option=value, and it passes an empty string as the script
argument when it would be more appropriate to pass no argument at all.

The patch attached fixes both these problems.

-- Package-specific info:

-- System Information:
Debian Release: squeeze/sid
  APT prefers maverick-updates
  APT policy: (500, 'maverick-updates'), (500, 'maverick-security'), (500, 'maverick')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.35-22-generic (SMP w/2 CPU cores)
Locale: LANG=en_NZ.UTF-8, LC_CTYPE=en_NZ.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages live-build depends on:
ii  cdebootstrap               0.5.6ubuntu1  Bootstrap a Debian system
ii  debootstrap                1.0.23ubuntu1 Bootstrap a basic Debian system

Versions of packages live-build recommends:
ii  cpio                   2.11-4ubuntu1     GNU cpio -- a program to manage ar
ii  gettext-base           0.18.1.1-1ubuntu2 GNU Internationalization utilities
ii  gnu-fdisk              1.2.4-3           Linux fdisk replacement based on l

Versions of packages live-build suggests:
ii  dosfstools          3.0.9-1              utilities for making and checking 
ii  fakeroot            1.14.4-1ubuntu1      Gives a fake root environment
ii  genext2fs           1.4.1-2.2            ext2 filesystem generator for embe
ii  genisoimage         9:1.1.10-1ubuntu3    Creates ISO-9660 CD-ROM filesystem
ii  grub                0.97-29ubuntu60      GRand Unified Bootloader (Legacy v
ii  memtest86+          4.10-1ubuntu2        thorough real-mode memory tester
ii  mtools              4.0.12-1             Tools for manipulating MSDOS files
ii  parted              2.3-2ubuntu1         The GNU Parted disk partition resi
ii  sudo                1.7.2p7-1ubuntu2     Provide limited super user privile
ii  syslinux            2:4.01+dfsg-3ubuntu1 collection of boot loaders
ii  uuid-runtime        2.17.2-0ubuntu1      runtime components for the Univers
pn  win32-loader        <none>               (no description available)

-- no debconf information
[debootstrap-argument-passing-fixes.diff (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Wed, 10 Nov 2010 23:33:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Wed, 10 Nov 2010 23:33:12 GMT) Full text and rfc822 format available.

Message #10 received at 603114@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Michael Hudson <michael.hudson@canonical.com>
Cc: 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Thu, 11 Nov 2010 00:32:36 +0100
found 603114 2.0~a21-1
notfound 603114 2.0~a21-1ubuntu1~linaro4ubuntu4
tag 603114 - patch
thanks

On 11/11/2010 12:12 AM, Michael Hudson wrote:
> Version: 2.0~a21-1ubuntu1~linaro4ubuntu4

this is a version not from debian, please use a debian version that
matches the code you're using.

> The patch attached fixes both these problems.

the patch doesn't apply on 2.0.x, could you please rebase on
debian-old-2.0 branch from git?

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Bug Marked as found in versions live-build/2.0~a21-1. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Wed, 10 Nov 2010 23:33:14 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions 2.0~a21-1ubuntu1~linaro4ubuntu4. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Wed, 10 Nov 2010 23:33:14 GMT) Full text and rfc822 format available.

Removed tag(s) patch. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Wed, 10 Nov 2010 23:33:15 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Thu, 11 Nov 2010 00:33:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Hudson <michael.hudson@canonical.com>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Thu, 11 Nov 2010 00:33:05 GMT) Full text and rfc822 format available.

Message #21 received at 603114@bugs.debian.org (full text, mbox):

From: Michael Hudson <michael.hudson@canonical.com>
To: daniel@debian.org
Cc: 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Thu, 11 Nov 2010 13:28:18 +1300
On Thu, 11 Nov 2010 00:32:36 +0100, Daniel Baumann <daniel@debian.org> wrote:
> found 603114 2.0~a21-1
> notfound 603114 2.0~a21-1ubuntu1~linaro4ubuntu4
> tag 603114 - patch
> thanks
> 
> On 11/11/2010 12:12 AM, Michael Hudson wrote:
> > Version: 2.0~a21-1ubuntu1~linaro4ubuntu4
> 
> this is a version not from debian, please use a debian version that
> matches the code you're using.

The version reported here is more or less irrevelant for this, I've not
been using an installed version.

> > The patch attached fixes both these problems.
> 
> the patch doesn't apply on 2.0.x, could you please rebase on
> debian-old-2.0 branch from git?

The patch was intended for HEAD, but applies to debian-old-2.0 cleanly
as far as I can tell.  What happens when you try to apply it?

Cheers,
mwh




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Sat, 13 Nov 2010 15:54:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Sat, 13 Nov 2010 15:54:08 GMT) Full text and rfc822 format available.

Message #26 received at 603114@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Michael Hudson <michael.hudson@canonical.com>
Cc: 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Sat, 13 Nov 2010 16:52:02 +0100
On 11/11/2010 01:28 AM, Michael Hudson wrote:
>> the patch doesn't apply on 2.0.x, could you please rebase on
>> debian-old-2.0 branch from git?
> 
> The patch was intended for HEAD, but applies to debian-old-2.0 cleanly
> as far as I can tell.  What happens when you try to apply it?

not that it matters (since the other commits up to 2.0.6 don't change
that file), but for the records: at the time you send the patch, the
newest commit on debian-old-2.0 was
60581a622765b82350e0f0ae78d0be31024aadab.

daniel@debian:/srv/vcs/debian-live/live-build$ patch -Np1 -i
/srv/temporary/download/debootstrap-argument-passing-fixes.diff --dry-run
patching file build/lb_bootstrap_debootstrap
Hunk #1 FAILED at 55.
Hunk #2 FAILED at 124.
Hunk #3 FAILED at 140.
3 out of 3 hunks FAILED -- saving rejects to file
build/lb_bootstrap_debootstrap.rej
daniel@debian:/srv/vcs/debian-live/live-build$

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Sun, 14 Nov 2010 20:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Hudson <michael.hudson@canonical.com>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Sun, 14 Nov 2010 20:27:03 GMT) Full text and rfc822 format available.

Message #31 received at 603114@bugs.debian.org (full text, mbox):

From: Michael Hudson <michael.hudson@canonical.com>
To: daniel@debian.org
Cc: 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Mon, 15 Nov 2010 09:25:17 +1300
On Sat, 13 Nov 2010 16:52:02 +0100, Daniel Baumann <daniel@debian.org> wrote:
> On 11/11/2010 01:28 AM, Michael Hudson wrote:
> >> the patch doesn't apply on 2.0.x, could you please rebase on
> >> debian-old-2.0 branch from git?
> > 
> > The patch was intended for HEAD, but applies to debian-old-2.0 cleanly
> > as far as I can tell.  What happens when you try to apply it?
> 
> not that it matters (since the other commits up to 2.0.6 don't change
> that file), but for the records: at the time you send the patch, the
> newest commit on debian-old-2.0 was
> 60581a622765b82350e0f0ae78d0be31024aadab.
> 
> daniel@debian:/srv/vcs/debian-live/live-build$ patch -Np1 -i
> /srv/temporary/download/debootstrap-argument-passing-fixes.diff --dry-run
> patching file build/lb_bootstrap_debootstrap
> Hunk #1 FAILED at 55.
> Hunk #2 FAILED at 124.
> Hunk #3 FAILED at 140.
> 3 out of 3 hunks FAILED -- saving rejects to file
> build/lb_bootstrap_debootstrap.rej
> daniel@debian:/srv/vcs/debian-live/live-build$

It works with -p0 :-) Apologies if I missed some convention here (the
diff was generated with bzr, not git, so that might explain the
difference).

Cheers,
mwh




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Sun, 14 Nov 2010 22:09:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Sun, 14 Nov 2010 22:09:05 GMT) Full text and rfc822 format available.

Message #36 received at 603114@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Michael Hudson <michael.hudson@canonical.com>
Cc: 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Sun, 14 Nov 2010 23:06:26 +0100
On 11/14/2010 09:25 PM, Michael Hudson wrote:
> It works with -p0 :-) Apologies if I missed some convention here (the
> diff was generated with bzr, not git, so that might explain the
> difference).

the first two changes are ok, but the second two have a typo (LH instead
of LB), and apart from the typo, i don't see why that change is usefull.
could you explain why you think it's good to do that?

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Sun, 14 Nov 2010 23:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Hudson <michael.hudson@canonical.com>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Sun, 14 Nov 2010 23:03:03 GMT) Full text and rfc822 format available.

Message #41 received at 603114@bugs.debian.org (full text, mbox):

From: Michael Hudson <michael.hudson@canonical.com>
To: daniel@debian.org
Cc: 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Mon, 15 Nov 2010 11:59:01 +1300
On Sun, 14 Nov 2010 23:06:26 +0100, Daniel Baumann <daniel@debian.org> wrote:
> On 11/14/2010 09:25 PM, Michael Hudson wrote:
> > It works with -p0 :-) Apologies if I missed some convention here (the
> > diff was generated with bzr, not git, so that might explain the
> > difference).
> 
> the first two changes are ok, but the second two have a typo (LH instead
> of LB),

Oops, sorry about that.

> and apart from the typo, i don't see why that change is usefull.
> could you explain why you think it's good to do that?

Well, as I said in the initial submission, it broke when using
qemu-debootstrap instead of debootstrap.  It's basically an
implementation accident in the argument parsing of deboostrap -- if it
changed to say '$# -ge 4' rather than '$4 != ""', live-build would stop
working.  It's all a bit theoretical and I think qemu-debootstrap is
going to be fixed to be more compatible with debootstrap here, so if you
think the cost to readability is too high, I can understand that.

Relatedly, would you be interested in patches that move towards making
live-build use qemu-deboostrap by default if cross building?  I have
some patches that work, but they're definitely a bit rough currently.

Cheers,
mwh




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Mon, 15 Nov 2010 08:06:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Mon, 15 Nov 2010 08:06:06 GMT) Full text and rfc822 format available.

Message #46 received at 603114@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Michael Hudson <michael.hudson@canonical.com>
Cc: 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Mon, 15 Nov 2010 09:04:29 +0100
On 11/14/2010 11:59 PM, Michael Hudson wrote:
> Well, as I said in the initial submission, it broke when using
> qemu-debootstrap instead of debootstrap.  It's basically an
> implementation accident in the argument parsing of deboostrap -- if it
> changed to say '$# -ge 4' rather than '$4 != ""', live-build would stop
> working.  It's all a bit theoretical and I think qemu-debootstrap is
> going to be fixed to be more compatible with debootstrap here, so if you
> think the cost to readability is too high, I can understand that.

that's for the first two changes which are fine as i said, but i've
asked about the second two changes:

-»······»·······${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
--download-only "${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
"${LB_DEBOOTSTRAP_SCRIPT}"
+»······»·······${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
--download-only "${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
${LH_DEBOOTSTRAP_SCRIPT:+"$LH_DEBOOTSTRAP_SCRIPT"}

[...]

-»······${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
"${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
"${LB_DEBOOTSTRAP_SCRIPT}"
+»······${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
"${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
${LH_DEBOOTSTRAP_SCRIPT:+"$LH_DEBOOTSTRAP_SCRIPT"}

i don't think they make sense. could explain why you think this should
be changed?

> Relatedly, would you be interested in patches that move towards making
> live-build use qemu-deboostrap by default if cross building?  I have
> some patches that work, but they're definitely a bit rough currently.

not for 2.x, since that's in maintenance mode. for 3.x, we're going to
drop a lot of code and support multistrap only. and multistrap already
allows to cross-bootstrap, so there's not much point in adding
qemu-debootstrap support. what do you think?

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Mon, 15 Nov 2010 20:51:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Hudson <michael.hudson@canonical.com>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Mon, 15 Nov 2010 20:51:06 GMT) Full text and rfc822 format available.

Message #51 received at 603114@bugs.debian.org (full text, mbox):

From: Michael Hudson <michael.hudson@canonical.com>
To: daniel@debian.org
Cc: 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Tue, 16 Nov 2010 09:50:21 +1300
On Mon, 15 Nov 2010 09:04:29 +0100, Daniel Baumann <daniel@debian.org> wrote:
> On 11/14/2010 11:59 PM, Michael Hudson wrote:
> > Well, as I said in the initial submission, it broke when using
> > qemu-debootstrap instead of debootstrap.  It's basically an
> > implementation accident in the argument parsing of deboostrap -- if it
> > changed to say '$# -ge 4' rather than '$4 != ""', live-build would stop
> > working.  It's all a bit theoretical and I think qemu-debootstrap is
> > going to be fixed to be more compatible with debootstrap here, so if you
> > think the cost to readability is too high, I can understand that.
> 
> that's for the first two changes which are fine as i said, 

No, it's not.

> but i've asked about the second two changes:
> 
> -        ${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
> --download-only "${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
> "${LB_DEBOOTSTRAP_SCRIPT}"
> +        ${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
> --download-only "${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
> ${LH_DEBOOTSTRAP_SCRIPT:+"$LH_DEBOOTSTRAP_SCRIPT"}

> i don't think they make sense. could explain why you think this should
> be changed?

This is the difference between passing '' and passing nothing as the
last argument:

$ foo=; set -- "${foo}"; echo $# x${1}x
1 xx
$ foo=; set -- ${foo:+"$foo"}; echo $# x${1}x
0 xx

It's passing an empty final argument to qemu-debootstrap rather than no
final argument that confuses it.

> > Relatedly, would you be interested in patches that move towards making
> > live-build use qemu-deboostrap by default if cross building?  I have
> > some patches that work, but they're definitely a bit rough currently.
>
> not for 2.x, since that's in maintenance mode. for 3.x, we're going to
> drop a lot of code and support multistrap only. and multistrap already
> allows to cross-bootstrap, so there's not much point in adding
> qemu-debootstrap support. what do you think?

I'm not sure, to be honest.  It'll likely be a while before we catch up
to 3.0 anyway -- we're still invoking 'lh build', not 'lb build'...

Cheers.
mwh




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Mon, 15 Nov 2010 21:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Mon, 15 Nov 2010 21:45:03 GMT) Full text and rfc822 format available.

Message #56 received at 603114@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Michael Hudson <michael.hudson@canonical.com>, 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Mon, 15 Nov 2010 22:43:53 +0100
On 11/15/2010 09:50 PM, Michael Hudson wrote:
>> that's for the first two changes which are fine as i said, 
> 
> No, it's not.

hm? i don't understand..

>> but i've asked about the second two changes:
>>
>> -        ${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
>> --download-only "${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
>> "${LB_DEBOOTSTRAP_SCRIPT}"
>> +        ${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
>> --download-only "${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
>> ${LH_DEBOOTSTRAP_SCRIPT:+"$LH_DEBOOTSTRAP_SCRIPT"}
> 
>> i don't think they make sense. could explain why you think this should
>> be changed?
> 
> This is the difference between passing '' and passing nothing as the
> last argument:
> 
> $ foo=; set -- "${foo}"; echo $# x${1}x
> 1 xx
> $ foo=; set -- ${foo:+"$foo"}; echo $# x${1}x
> 0 xx
> 
> It's passing an empty final argument to qemu-debootstrap rather than no
> final argument that confuses it.

but LB_DEBOOTSTRAP_SCRIPT is never empty.

>> not for 2.x, since that's in maintenance mode. for 3.x, we're going to
>> drop a lot of code and support multistrap only. and multistrap already
>> allows to cross-bootstrap, so there's not much point in adding
>> qemu-debootstrap support. what do you think?
> 
> I'm not sure, to be honest.  It'll likely be a while before we catch up
> to 3.0 anyway -- we're still invoking 'lh build', not 'lb build'...

once squeeze is released, 2.x is dead and you'll have to maintain it on
your own for anything non-serious that isn't affecting squeeze. i hope
you can update to 3.x by then, and suggest you help working on 3.x
rather than wasting time with 2.x.

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#603114; Package live-build. (Tue, 16 Nov 2010 00:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Hudson <michael.hudson@canonical.com>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Tue, 16 Nov 2010 00:00:03 GMT) Full text and rfc822 format available.

Message #61 received at 603114@bugs.debian.org (full text, mbox):

From: Michael Hudson <michael.hudson@canonical.com>
To: daniel@debian.org, 603114@bugs.debian.org
Subject: Re: Bug#603114: live-build: be more careful in passing arguments to debootstrap
Date: Tue, 16 Nov 2010 12:57:45 +1300
On Mon, 15 Nov 2010 22:43:53 +0100, Daniel Baumann <daniel@debian.org> wrote:
> On 11/15/2010 09:50 PM, Michael Hudson wrote:
> >> that's for the first two changes which are fine as i said, 
> > 
> > No, it's not.
> 
> hm? i don't understand..
> 
> >> but i've asked about the second two changes:
> >>
> >> -        ${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
> >> --download-only "${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
> >> "${LB_DEBOOTSTRAP_SCRIPT}"
> >> +        ${LB_ROOT_COMMAND} debootstrap ${DEBOOTSTRAP_OPTIONS}
> >> --download-only "${LB_DISTRIBUTION}" chroot "${LB_MIRROR_BOOTSTRAP}"
> >> ${LH_DEBOOTSTRAP_SCRIPT:+"$LH_DEBOOTSTRAP_SCRIPT"}
> > 
> >> i don't think they make sense. could explain why you think this should
> >> be changed?
> > 
> > This is the difference between passing '' and passing nothing as the
> > last argument:
> > 
> > $ foo=; set -- "${foo}"; echo $# x${1}x
> > 1 xx
> > $ foo=; set -- ${foo:+"$foo"}; echo $# x${1}x
> > 0 xx
> > 
> > It's passing an empty final argument to qemu-debootstrap rather than no
> > final argument that confuses it.
> 
> but LB_DEBOOTSTRAP_SCRIPT is never empty.

Now it's my turn to be confused.  LB_DEBOOTSTRAP_SCRIPT is not set if
LB_BOOTSTRAP_CONFIG is empty (which is the default):

if [ -n "${LB_BOOTSTRAP_CONFIG}" ]
then
	if [ -d "/usr/share/debootstrap/scripts/" ]
	then
		LB_DEBOOTSTRAP_SCRIPT="/usr/share/debootstrap/scripts/${LB_BOOTSTRAP_CONFIG}"
	else
		LB_DEBOOTSTRAP_SCRIPT="/usr/lib/debootstrap/scripts/${LB_BOOTSTRAP_CONFIG}"
	fi
fi

> >> not for 2.x, since that's in maintenance mode. for 3.x, we're going to
> >> drop a lot of code and support multistrap only. and multistrap already
> >> allows to cross-bootstrap, so there's not much point in adding
> >> qemu-debootstrap support. what do you think?
> > 
> > I'm not sure, to be honest.  It'll likely be a while before we catch up
> > to 3.0 anyway -- we're still invoking 'lh build', not 'lb build'...
> 
> once squeeze is released, 2.x is dead and you'll have to maintain it on
> your own for anything non-serious that isn't affecting squeeze. i hope
> you can update to 3.x by then, and suggest you help working on 3.x
> rather than wasting time with 2.x.

Where is the code for 3.x?

Cheers,
mwh




Changed Bug title to 'be more careful in passing arguments to debootstrap' from 'live-build: be more careful in passing arguments to debootstrap' Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Mon, 16 May 2011 12:45:06 GMT) Full text and rfc822 format available.

Reply sent to Daniel Baumann <daniel@debian.org>:
You have taken responsibility. (Fri, 03 Jun 2011 11:21:14 GMT) Full text and rfc822 format available.

Notification sent to Michael Hudson <michael.hudson@canonical.com>:
Bug acknowledged by developer. (Fri, 03 Jun 2011 11:21:15 GMT) Full text and rfc822 format available.

Message #68 received at 603114-close@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 603114-close@bugs.debian.org
Subject: Bug#603114: fixed in live-build 3.0~a18-1
Date: Fri, 03 Jun 2011 11:20:22 +0000
Source: live-build
Source-Version: 3.0~a18-1

We believe that the bug you reported is fixed in the latest version of
live-build, which is due to be installed in the Debian FTP archive:

live-build-cgi_3.0~a18-1_all.deb
  to main/l/live-build/live-build-cgi_3.0~a18-1_all.deb
live-build_3.0~a18-1.debian.tar.gz
  to main/l/live-build/live-build_3.0~a18-1.debian.tar.gz
live-build_3.0~a18-1.dsc
  to main/l/live-build/live-build_3.0~a18-1.dsc
live-build_3.0~a18-1_all.deb
  to main/l/live-build/live-build_3.0~a18-1_all.deb
live-build_3.0~a18.orig.tar.gz
  to main/l/live-build/live-build_3.0~a18.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 603114@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Baumann <daniel@debian.org> (supplier of updated live-build package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Fri, 03 Jun 2011 11:59:30 +0200
Source: live-build
Binary: live-build live-build-cgi
Architecture: source all
Version: 3.0~a18-1
Distribution: unstable
Urgency: low
Maintainer: Debian Live Project <debian-live@lists.debian.org>
Changed-By: Daniel Baumann <daniel@debian.org>
Description: 
 live-build - Debian Live - System Build Scripts
 live-build-cgi - Debian Live - System Build Scripts (cgi frontend)
Closes: 603114 627183 627406 627695 627902 628897
Changes: 
 live-build (3.0~a18-1) unstable; urgency=low
 .
   [ Colin Watson ]
   * Fix duplicate deconfiguration of apt, upstart, and sysv-rc if build-
     with-chroot is false (Closes: #627406).
 .
   [ Daniel Baumann ]
   * Correcting accidentally unconditional default for linux-flavours in
     progress mode.
   * Restoring excludes functionality for mksquashfs. This was present
     some time ago but then got removed.
   * Moving 'default' hooks for minimal and stripped to example hooks,
     they will have to be enabled manually now (Closes: #627183).
 .
   [ Colin Watson ]
   * Fixing ext2/ext3 case in lb_binary_rootfs to work with --build-with-
     chroot false (Closes: #627902).
 .
   [ Daniel Baumann ]
   * Removing accidentally twice included English files when installing
     manpages (Closes: #628897).
   * Removing unused and not really usefull bootstrap-script option
     (Closes: #603114).
   * Correcting wrong task defaults.
   * Updating grub paths for d-i files (Closes: #627695).
Checksums-Sha1: 
 4d20b3b826ee9a77d0205c3c53cbfdc66b220e98 1282 live-build_3.0~a18-1.dsc
 809da37602a48b1248e987610d3bf0ed047f2ca3 1927410 live-build_3.0~a18.orig.tar.gz
 9ff01af47740331c89179ee7f75d37246831ddec 41162 live-build_3.0~a18-1.debian.tar.gz
 7fc7b29f3657ce0cfe7134a4f39ccaf98ac0d531 1132416 live-build_3.0~a18-1_all.deb
 36ac492a7e07de05b4a5ad756af9752184c19da9 57498 live-build-cgi_3.0~a18-1_all.deb
Checksums-Sha256: 
 e382617101c0cf315844353a848f0f1e5529cfcd46a4c2b6f164d9b1a2dadc41 1282 live-build_3.0~a18-1.dsc
 bebc6c07efb4cb1691d651e8e6efcb3eb2103d7f0ac1d79b68d18a3fb873cb98 1927410 live-build_3.0~a18.orig.tar.gz
 b0f9247d834dbc2e995026a6ec4c864c60828ba19dd43fc409fd96eaa00db39e 41162 live-build_3.0~a18-1.debian.tar.gz
 feff5db7515a313f8ead84c00c31d50a46dec1e56de8c3466d28a08c08834321 1132416 live-build_3.0~a18-1_all.deb
 c0a3a0dda86523278ef65877bece7b10dc426246063a5e26521f38b1992377e2 57498 live-build-cgi_3.0~a18-1_all.deb
Files: 
 ec19ee1ea3532925f60a0f2c507cb931 1282 misc optional live-build_3.0~a18-1.dsc
 cc646d35211a2440ea5a1df7fce1bd5c 1927410 misc optional live-build_3.0~a18.orig.tar.gz
 07f6648f7e5664d70791939d240455fe 41162 misc optional live-build_3.0~a18-1.debian.tar.gz
 2fd4299735b42f00c3075a1ee4aa6f9d 1132416 misc optional live-build_3.0~a18-1_all.deb
 436e50f4235c52950201f0a0a93fb4d1 57498 misc optional live-build-cgi_3.0~a18-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAk3osgkACgkQ+C5cwEsrK56myACfW1aEeSgco8ATnXMybenzpXtH
VNYAniGzwaxqgEMCu4MJ4DBXvBP0tOLX
=UbSX
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 02 Jul 2011 07:34:04 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 00:42:29 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.